Posts Tagged ‘vulnerabilidad’

h1

Vulnerabilidades en Tomcat

9 octubre 2009

Se han encontrado varios dos fallos de seguridad en las siguientes versiones de tomcat:

Tomcat 4.1.0 al 4.1.37

Tomcat 5.5.0 al 5.5.26

Tomcat 6.0.0 al 6.0.16

Estas vulnerabilidades son:

1)En el RequestDispatcher la ruta de destino se normalizó antes de que la cadena de consulta se ha retirado. Por lo tanto si se pone un parámetro malicioso en la consulta se puede conseguir acceder a información restringida o información que se encuentre en el WEB-IND

Ejemplo:

Una página que tenga:

<%

pageContext.forward("/page2.jsp?somepar=someval&par="+request.getParamet

er("blah"));

%>

El hacker puede usar:

http://host/page.jsp?blah=/../WEB-INF/web.xml

2) HttpServletResponse.sendError () no es sólo aparece en la página de error, también se utiliza en el HTTP response. Esto puede incluir caracteres que son ilegales en las cabeceras HTTP. Con un esto se puede conseguir un ataque XSS, al inyectar contenido arbitrario en la respuesta HTTP.

Por ejemplo:

<%@page contentType=”text/html”%>

<%

final String CRLF = "\u010D\u010A";

final String payload = CRLF + CRLF + "<script

type='text/javascript'>document.write('Hi, there!')</script><div style='display:none'>";

final String message = "Authorization is required to access " + payload;

response.sendError(403, message);

%>
Anuncios